#!/bin/env python
###	sseaxis.py	Matthew Baker 09/2003

#N sseaxis.py
#F sse medial axis

import os
import sys
import string
import commands
import math
import EMAN
from math import *
from sys import argv
from Numeric import array
from Numeric import dot
from Numeric import transpose

if (len(argv)!=4) :
	print "Usage:\nsseaxis.py <input pdb file> <apix> <iterations>\n"
	sys.exit(1)

target=argv[1]
apix=float(argv[2])
iterations=int(argv[3])

file=open(target, "r")
lines=file.readlines()
file.close()

x=[]
y=[]
z=[]
atomNumber=[]
counter=0

for line in lines:
	isatom=str(line[0:6].strip())
	if (isatom=="ATOM"):
		x.append(float(line[30:38].strip()))
		y.append(float(line[38:46].strip()))
		z.append(float(line[46:54].strip()))
		atomNumber.append(int(line[6:11].strip()))
		counter=counter+1

iterationcounter=0
while iterationcounter < iterations:
	xnew=[]*counter
	ynew=[]*counter
	znew=[]*counter
	i=0
	while (i < counter):
		x1=x[i]
		y1=y[i]
		z1=z[i]
		neighbor1distance=99999999.0
		neighbor2distance=99999999.0
		point1=0
		point2=0
		j=0
		while (j < counter):
			if i!=j:
				x2=x[j]
				y2=y[j]
				z2=z[j]
				distance=math.sqrt((x1-x2)**2+(y1-y2)**2+(z1-z2)**2)
				if  distance < neighbor2distance:
					if distance < neighbor1distance:
						neighbor2distance=neighbor1distance
						neighbor1distance=distance
						point2=point1
						point1=j
					else:
						neighbor2distance=distance
						point2=j
			j=j+1
		print atomNumber[i], atomNumber[point1], neighbor1distance, atomNumber[point2], neighbor2distance
		xnew.append((x[point1]+x[point2])/2)
		ynew.append((y[point1]+y[point2])/2)
		znew.append((z[point1]+z[point2])/2)
		print xnew[i], ynew[i], znew[i]
		i=i+1
	x=xnew
	y=ynew
	z=znew
	iterationcounter=iterationcounter+1
	
	outfile="medial-%s"%(target)
	out=open(outfile,"w")
	index=0
	for i in lines:
		out.write(i[:30]+" %7.2f %7.2f %7.2f"%(x[index],y[index],z[index])+i[54:])
		index=index+1
	out.close()
