import os
import sys
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window

class bilateral(ModelessDialog):
	name = "bfc ui"
	buttons = ("Apply","Close")
	title = "bilateral filter"
	direman=os.environ["HOME"]
	hellp = "%s/EMAN/doc/blfilt_help.html"%(direman)
	help = hellp

	def fileselector(self):
		##generate list of open volume files
		self.files=[]
		self.index=0
		self.files=map(lambda x:x.name,filter(lambda x:str(x.__class__)=="VolumeViewer.surface.Surface_Model",chimera.openModels.list()))
		self.fileButton.setitems(self.files)
		
	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame1=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame1.grid(column=0,row=1, sticky=EW)

		Label(self.frame0, text='input file:').grid(row=0, column=0, sticky=W)
		self.infile=StringVar()
		self.fileButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.infile)
		self.fileButton.grid(row=0, column=1, sticky=W)
		self.fileselector()
		self.filechoice=IntVar()
		q = Checkbutton(self.frame0, text="Use external file", variable=self.filechoice).grid(row=1, sticky=W)
		self.infile2 = Entry(self.frame0, width = 8)		
		self.infile2.grid(row=1, column=1, sticky=W)

		Label(self.frame1, text='sigma1').grid(row=0, sticky=W)
		Label(self.frame1, text='sigma2').grid(row=1, sticky=W)
		Label(self.frame1, text='iter').grid(row=2, sticky=W)
		Label(self.frame1, text='width').grid(row=3, sticky=W)		
		
		sigma1=StringVar()
		self.sigma1 = Entry(self.frame1, textvariable=sigma1, width = 8)
		sigma1.set("0")
		sigma2=StringVar()
		self.sigma2 = Entry(self.frame1, textvariable=sigma2, width = 8)
		sigma2.set("0")
		iter=StringVar()
		self.iter = Entry(self.frame1, textvariable=iter, width = 8)
		iter.set("0")
		wid=StringVar()
		self.wid = Entry(self.frame1, textvariable=wid, width = 8)
		wid.set("0")

		self.sigma1.grid(row=0, column=1, sticky=W)
		self.sigma2.grid(row=1, column=1, sticky=W)
		self.iter.grid(row=2, column=1, sticky=W)
		self.wid.grid(row=3, column=1, sticky=W)
		
		return self.infile

	def Apply(self):
		if (self.filechoice.get()==0):
			infile = str(self.infile.get())
		else: 
			infile = str(self.infile2.get())
			
		sigma1= float(self.sigma1.get())
		sigma2=float(self.sigma2.get())
		iter=int(self.iter.get())
		width=float(self.wid.get())

		print "Filtering Map"
		outfile="bf-%s"%(infile)
		print infile,outfile,sigma1,sigma2,iter,width
		cmd0="proc3d %s %s blfilt=%f,%f,%d,%f"%(infile,outfile,sigma1,sigma2,iter,width)
		print cmd0
		os.system(cmd0)
		
		chimera.openModels.open(outfile)
try:
	chimera.dialogs.register(bilateral.name, bilateral)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = bilateral()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) : dialog.fileselector()

triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)
		
		
		
		
