import os
import sys
import string
import commands
from sys import argv
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window


class hh3c(ModelessDialog):
	name = "hh3c ui"
	buttons = ("Apply","Close")
	title = "helixhunter"
	direman=os.environ["HOME"]
	hellp = "%s/EMAN/doc/hh3c_help.html"%(direman)
	help = hellp

	def targetSelector(self):
		##generate list of open volume files
		self.targets=[]
		self.targets=map(lambda x:x.name,chimera.openModels.list())
		self.targetButton.setitems(self.targets)

	def hhSelector(self):
		##generate list of open volume files
		self.hhselector=[]
		self.hhselector=map(lambda x:x.name,filter(lambda x:str(x.__class__)=="VolumeViewer.surface.Surface_Model",chimera.openModels.list()))
		self.hhselector.insert(0,"None")
		self.intButton.setitems(self.hhselector)
		
	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame1=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame1.grid(column=0,row=1, sticky=EW)
		self.frame2=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame2.grid(column=0,row=2, sticky=EW)

		##Target Selection
		Label(self.frame0, text='target file:').grid(row=0, column=0, sticky=W)
		self.target=StringVar()
		self.targetButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.target)
		self.targetButton.grid(row=0, column=1, sticky=W)
		self.targetSelector()
		self.filechoiceTarget=IntVar()
		t = Checkbutton(self.frame0, text="Use file", variable=self.filechoiceTarget).grid(row=1, sticky=W)
		self.target2 = Entry(self.frame0, width = 16)
		self.target2.grid(row=1, column=1, sticky=W)
		Label(self.frame0, text='helixhunter file:').grid(row=2, column=0, sticky=W)
		self.intfile=StringVar()
		self.intButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.intfile)
		self.intButton.grid(row=2, column=1, sticky=W)
		self.hhSelector()
		
		##Required parameters
		apix=StringVar()
		Label(self.frame0, text='apix:').grid(row=4, column=0, sticky=W)
		self.apix = Entry(self.frame0, width = 6, textvariable=apix)
		self.apix.grid(row=3, column=1, sticky=W)
		apix.set("1")
		
		##optional parameters
		filternumber=StringVar()
		Label(self.frame1, text='filter threshold:').grid(row=0, column=0, sticky=W)
		self.filternumber = Entry(self.frame1, width = 6, textvariable=filternumber)
		self.filternumber.grid(row=0, column=1, sticky=W)
		filternumber.set("0.5")

		hhthr=StringVar()
		Label(self.frame1, text='helixhunter threshold:').grid(row=1, column=0, sticky=W)
		self.hhthr = Entry(self.frame1, width = 6, textvariable=hhthr)
		self.hhthr.grid(row=1, column=1, sticky=W)
		hhthr.set("0.3")
		
		angle=StringVar()
		Label(self.frame1, text='angle:').grid(row=0, column=2, sticky=W)
		self.angle = Entry(self.frame1, width = 6, textvariable=angle)
		self.angle.grid(row=0, column=3, sticky=W)
		angle.set("75")

		dist=StringVar()
		Label(self.frame1, text='dist:').grid(row=1, column=2, sticky=W)
		self.dist = Entry(self.frame1, width = 6, textvariable=dist)
		self.dist.grid(row=1, column=3, sticky=W)
		dist.set("4.0")
		
		trans=StringVar()
		Label(self.frame1, text='translate:').grid(row=2, column=0, sticky=W)
		self.trans = Entry(self.frame1, width = 6, textvariable=trans)
		self.trans.grid(row=2, column=1, sticky=W)
		trans.set("0.0")
				
		##Segment3d parameters
		Label(self.frame2, text='Segment options').grid(row=0, column=0, sticky=W)

		nseg=StringVar()
		Label(self.frame2, text='nseg:').grid(row=1, column=0, sticky=W)
		self.nseg = Entry(self.frame2, width = 6, textvariable=nseg)
		self.nseg.grid(row=1, column=1, sticky=W)
		nseg.set("200")
		
		thr=StringVar()
		Label(self.frame2, text='thr:').grid(row=1, column=2, sticky=W)
		self.thr = Entry(self.frame2, width = 6, textvariable=thr)
		self.thr.grid(row=1, column=3, sticky=W)
		thr.set("0.3")

		
	def Apply(self):
		if (self.filechoiceTarget.get()==0):
			target=self.target.get()
		else:
			target=self.target2.get()

		t=target.split('.')
		targetNAME=str(t[0])
		targetEXT=str(t[-1])

		apix=float(self.apix.get())
		hhint=self.intfile.get()
		filternumber=float(self.filternumber.get())
		hhthr=float(self.hhthr.get())
		angle=float(self.angle.get())
		dist=float(self.dist.get())
		finaltrans=float(self.trans.get())
		
		nseg=int(self.nseg.get())
		thr=float(self.thr.get())

		if targetEXT=="pdb" or targetEXT=="ent":
			cmd0="hh3.py %s %f hh=%s hhthr=%f filternumber=%f angle=%f dist=%f "%(target,apix,hhint,hhthr,filternumber,angle,dist)
		if targetEXT=="mrc":
#			targetfile=EMAN.EMData()
#			targetfile.readImage(target,-1)
#			target_size=targetfile.xSize()
#			finaltrans=-0.5*target_size*apix
			
			if hhint!="None":
				cmd0="hh3.py %s %f hh=%s hhthr=%f seg=%d thr=%f filternumber=%f angle=%f dist=%f trans=%f"%(target,apix,hhint,hhthr,nseg,thr,filternumber,angle,dist,finaltrans)
			else:
				cmd0="hh3.py %s %f hhthr=%f seg=%d thr=%f filternumber=%f angle=%f dist=%f trans=%f"%(target,apix,hhthr,nseg,thr,filternumber,angle,dist,finaltrans)
		print cmd0
		os.system(cmd0)

		openFile="hh-%s-%f-%f.pdb"%(targetNAME,filternumber,dist)
		chimera.openModels.open(openFile)

try:
	chimera.dialogs.register(hh3c.name, hh3c)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = hh3c()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) :
		dialog.targetSelector()
		dialog.hhSelector()
triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)
