import os
import sys
import string
import commands
from sys import argv
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window


class sheethunter(ModelessDialog):
	name = "shc ui"
	buttons = ("Apply","Close")
	title = "sheethunter"
	direman=os.environ["HOME"]
	hellp = "%s/EMAN/doc/sh_help.html"%(direman)
	help = hellp

	def targetSelector(self):
		##generate list of open volume files
		self.targets=[]
		self.targets=map(lambda x:x.name,chimera.openModels.list())
		self.targetButton.setitems(self.targets)
	def filterSelector(self):
		self.filters=[]
		self.filters=map(lambda x:x.name,filter(lambda x:str(x.__class__)=="VolumeViewer.surface.Surface_Model",chimera.openModels.list()))
		self.hhButton.setitems(self.filters)

	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame1=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame1.grid(column=0,row=1, sticky=EW)
		self.frame2=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame2.grid(column=0,row=2, sticky=EW)
		

		##Target Selection
		Label(self.frame0, text='target file:').grid(row=0, column=0, sticky=W)
		self.target=StringVar()
		self.targetButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.target)
		self.targetButton.grid(row=0, column=1, sticky=W)
		self.targetSelector()
		self.filechoiceTarget=IntVar()
		t = Checkbutton(self.frame0, text="Use external file", variable=self.filechoiceTarget).grid(row=1, sticky=W)
		self.target2 = Entry(self.frame0, width = 16)
		self.target2.grid(row=1, column=1, sticky=W)
		
		##Required parameters
		apix=StringVar()
		Label(self.frame1, text='apix:').grid(row=0, column=0, sticky=W)
		self.apix = Entry(self.frame1, width = 6, textvariable=apix)
		self.apix.grid(row=0, column=1, sticky=W)
		apix.set("1")
		
		nseg=StringVar()
		Label(self.frame1, text='nseg:').grid(row=1, column=0, sticky=W)
		self.nseg = Entry(self.frame1, width = 6, textvariable=nseg)
		self.nseg.grid(row=1, column=1, sticky=W)
		nseg.set("200")

		thr=StringVar()
		Label(self.frame1, text='thr:').grid(row=2, column=0, sticky=W)
		self.thr = Entry(self.frame1, width = 6, textvariable=thr)
		self.thr.grid(row=2, column=1, sticky=W)
		thr.set("1")

		angle=StringVar()
		Label(self.frame1, text='angle:').grid(row=0, column=2, sticky=W)
		self.angle = Entry(self.frame1, width = 6, textvariable=angle)
		self.angle.grid(row=0, column=3, sticky=W)
		angle.set("45")

		dist=StringVar()
		Label(self.frame1, text='dist:').grid(row=1, column=2, sticky=W)
		self.dist = Entry(self.frame1, width = 6, textvariable=dist)
		self.dist.grid(row=1, column=3, sticky=W)
		dist.set("5.5")
		
		##filter Parameters
		self.hhf=IntVar()
		f = Checkbutton(self.frame2, text="HH filter", variable=self.hhf).grid(row=0, sticky=W)

		Label(self.frame2, text='hh filter file:').grid(row=1, column=0, sticky=W)
		self.hh=StringVar()
		self.hhButton=Pmw.OptionMenu(self.frame2,labelpos=W, menubutton_textvariable=self.hh)
		self.hhButton.grid(row=1, column=1, sticky=W)
		self.filterSelector()

		hhthr=StringVar()
		Label(self.frame2, text='hhthr:').grid(row=2, column=0, sticky=W)
		self.hhthr = Entry(self.frame2, width = 6, textvariable=hhthr)
		self.hhthr.grid(row=2, column=1, sticky=W)
		hhthr.set("0.3")
		
	def Apply(self):
		refineFLAG=0
		if (self.filechoiceTarget.get()==0):
			target=self.target.get()
		else:
			target=self.target2.get()

		t=target.split('.')
		targetEXT=str(t[-1])

		if (self.hhf.get()==1):
			hh=self.hh.get()
			hht=float(self.hhthr.get())
			refineFLAG=1

		apix=float(self.apix.get())
		nseg=int(self.nseg.get())
		thr=float(self.thr.get())
		angle=float(self.angle.get())
		dist=float(self.dist.get())

		if targetEXT=="mrc" and refineFLAG==0:
			cmd0="~/NEW-EMAN/src/eman/src/sheethunter2.py %s seg=%d thr=%f angle=%f dist=%f"%(target,nseg,thr,angle,dist)
		if targetEXT=="mrc" and refineFLAG==1:
			cmd0="~/NEW-EMAN/src/eman/src/sheethunter2.py %s seg=%d thr=%f angle=%f dist=%f hh=%s hhthr=%f"%(target,nseg,thr,angle,dist,hh,hht)
		if targetEXT=="pdb" and refineFLAG==0:
			cmd0="~/NEW-EMAN/src/eman/src/sheethunter2.py %s angle=%f dist=%f"%(target,angle,dist)
		if targetEXT=="pdb" and refineFLAG==1:
			cmd0="~/NEW-EMAN/src/eman/src/sheethunter2.py %s angle=%f dist=%f hh=%s hhthr=%f"%(target,angle,dist,hh,hht)
		print cmd0
		os.system(cmd0)

		openFile="sheet-%f-%f.pdb"%(angle,dist)
		chimera.openModels.open(openFile)

try:
	chimera.dialogs.register(sheethunter.name, sheethunter)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = sheethunter()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) :
		dialog.targetSelector()
		dialog.filterSelector()
triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)