import os
import sys
import string
import commands
from sys import argv
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window


class ssc(ModelessDialog):
	name = "ssc ui"
	buttons = ("Apply","Close")
	title = "Secondary Structure Element Hunter"
	direman=os.environ["HOME"]
	hellp = "%s/EMAN/doc/hh3c_help.html"%(direman)
	help = hellp

	def targetSelector(self):
		##generate list of open volume files
		self.targets=[]
		self.targets=map(lambda x:x.name,chimera.openModels.list())
		self.targetButton.setitems(self.targets)

	def hhSelector(self):
		##generate list of open volume files
		self.hhselector=[]
		self.hhselector=map(lambda x:x.name,filter(lambda x:str(x.__class__)=="VolumeViewer.surface.Surface_Model",chimera.openModels.list()))
		self.hhselector.insert(0,"None")
		self.intButton.setitems(self.hhselector)
		
	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame12=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame12.grid(column=0,row=1, sticky=EW)
		self.frame1=Tkinter.Frame(self.frame12, bd=2, relief=FLAT)
		self.frame1.grid(column=0,row=0, sticky=EW)
		self.frame2=Tkinter.Frame(self.frame12, bd=2, relief=FLAT)
		self.frame2.grid(column=1,row=0, sticky=EW)
		self.frame3=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame3.grid(column=0,row=2, sticky=EW)		
		self.frame4=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame4.grid(column=0,row=3, sticky=EW)	
		
		##Target Selection
		Label(self.frame0, text='target file:').grid(row=0, column=0, sticky=W)
		self.target=StringVar()
		self.targetButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.target)
		self.targetButton.grid(row=0, column=1, sticky=W)
		self.targetSelector()
		Label(self.frame0, text='coefficient file:').grid(row=1, column=0, sticky=W)
		self.intfile=StringVar()
		self.intButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.intfile)
		self.intButton.grid(row=1, column=1, sticky=W)
		self.hhSelector()
		coeff=StringVar()
		Label(self.frame0, text='correlation value:').grid(row=1, column=2, sticky=W)
		self.coeff = Entry(self.frame0, width = 6, textvariable=coeff)
		self.coeff.grid(row=1, column=3, sticky=W)
		coeff.set("0.3")
				
		##Required parameters
		Label(self.frame1, text='Required Parameters').grid(row=0, column=0, sticky=W)
		apix=StringVar()
		Label(self.frame1, text='angstrom/pixel:').grid(row=1, column=0, sticky=W)
		self.apix = Entry(self.frame1, width = 6, textvariable=apix)
		self.apix.grid(row=1, column=1, sticky=W)
		apix.set("1")
		res=StringVar()
		Label(self.frame1, text='resolution:').grid(row=2, column=0, sticky=W)
		self.res = Entry(self.frame1, width = 6, textvariable=res)
		self.res.grid(row=2, column=1, sticky=W)
		res.set("6")
		
		##Segment3d parameters
		Label(self.frame2, text='Segment Parameters').grid(row=0, column=0, sticky=W)
		nseg=StringVar()
		Label(self.frame2, text='segments:').grid(row=1, column=0, sticky=W)
		self.nseg = Entry(self.frame2, width = 6, textvariable=nseg)
		self.nseg.grid(row=1, column=1, sticky=W)
		nseg.set("200")
		thr=StringVar()
		Label(self.frame2, text='threshold:').grid(row=2, column=0, sticky=W)
		self.thr = Entry(self.frame2, width = 6, textvariable=thr)
		self.thr.grid(row=2, column=1, sticky=W)
		thr.set("2")
		
		##optional parameters
		Label(self.frame3, text='Advanced Parameters').grid(row=0, column=0, sticky=W)
		
		Hangle=StringVar()
		Label(self.frame3, text='helix angle:').grid(row=1, column=0, sticky=W)
		self.Hangle = Entry(self.frame3, width = 6, textvariable=Hangle)
		self.Hangle.grid(row=1, column=1, sticky=W)
		Hangle.set("75")
		Hdist=StringVar()
		Label(self.frame3, text='helix distance:').grid(row=2, column=0, sticky=W)
		self.Hdist = Entry(self.frame3, width = 6, textvariable=Hdist)
		self.Hdist.grid(row=2, column=1, sticky=W)
		Hdist.set("7.5")

		Bangle=StringVar()
		Label(self.frame3, text='sheet angle:').grid(row=1, column=2, sticky=W)
		self.Bangle = Entry(self.frame3, width = 6, textvariable=Bangle)
		self.Bangle.grid(row=1, column=3, sticky=W)
		Bangle.set("75")
		Bdist=StringVar()
		Label(self.frame3, text='sheet distance:').grid(row=2, column=2, sticky=W)
		self.Bdist = Entry(self.frame3, width = 6, textvariable=Bdist)
		self.Bdist.grid(row=2, column=3, sticky=W)
		Bdist.set("5.0")		

		##Filter parameters
		Label(self.frame4, text='Filter Results').grid(row=0, column=0, sticky=W)
		Label(self.frame4, text='filter by:').grid(row=1, column=0, sticky=W)
		self.filter=StringVar()
		self.filter.set('magic')
		options=['magic', 'sigma', 'angle', 'correlation', 'points']
		self.filterButton=Pmw.OptionMenu(self.frame4,labelpos=W, menubutton_textvariable=self.filter, items=options)
		self.filterButton.grid(row=1, column=1, sticky=W)
		
		filtervalue=StringVar()
		self.filterValue = Entry(self.frame4, width = 6, textvariable=filtervalue)
		self.filterValue.grid(row=1, column=2, sticky=W)
		filtervalue.set("4.0")
		
	def Apply(self):
		target=str(self.target.get())
		apix=float(self.apix.get())
		res=float(self.res.get())
		t=target.split('.')
		targetNAME=str(t[0])
		
		hhint=str(self.intfile.get())
		hhthr=float(self.coeff.get())	

		Hangle=float(self.Hangle.get())
		Hdist=float(self.Hdist.get())
		Bangle=float(self.Bangle.get())
		Bdist=float(self.Bdist.get())

		nseg=int(self.nseg.get())
		thr=float(self.thr.get())

		filtertype=str(self.filter.get())
		filtervalue=float(self.filterValue.get())

		print target,apix,nseg,thr,Hdist,Hangle,filtertype,filtervalue,Bdist,Bangle,hhint,hhthr

		logfile="log-%s-hd-%f-ha-%f-sd-%f-sa-%f.txt"%(target,Hdist,Hangle,Bdist,Bangle)

		if hhint=="None":
			cmd0="ssehunter.py %s %f seg=%d thr=%f helixdist=%f helixangle=%f filtertype=%s filtervalue=%f sheetdist=%f sheetangle=%f > %s"%(target,apix,nseg,thr,Hdist,Hangle,filtertype,filtervalue,Bdist,Bangle,logfile)
		else:
			cmd0="ssehunter.py %s %f seg=%d thr=%f helixdist=%f helixangle=%f filtertype=%s filtervalue=%f sheetdist=%f sheetangle=%f hh=%s hhthr=%f >%s"%(target,apix,nseg,thr,Hdist,Hangle,filtertype,filtervalue,Bdist,Bangle,hhint,hhthr,logfile)

		print cmd0
		print sys.path
		os.system(cmd0)

		hfile="helix-%s-%f-%f-%s-%f.pdb"%(targetNAME,Hangle,Hdist,filtertype,filtervalue)
		bfile="sheet-%f-%f.pdb"%(Bangle,Bdist)
		cmd1="mv helix2.pdb %s"%(hfile)
		os.system(cmd1)
		chimera.openModels.open(hfile)
		chimera.openModels.open(bfile)
		chimera.openModels.open("maybe-helix.pdb")
		chimera.openModels.open("not-so-good-helices.pdb")

try:
	chimera.dialogs.register(ssc.name, ssc)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = ssc()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) :
		dialog.targetSelector()
		dialog.hhSelector()
triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)
