import os
import sys
import string
#import EMAN
import commands
import math
import re
import shutil
from math import *
from sys import argv
import Tkinter
from Tkinter import *
import tkMessageBox
import Pmw

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
	import VolumeViewer
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window
	
class ssebuilder(ModelessDialog):
	name = "ssebuilder ui"
#	buttons = ("Add","Delete","Build","Close")
	buttons = ("Build","Close")
	title = "SSE Builder"
	direman=os.environ["HOME"]
	hellp = "%s/EMAN/doc/sseb_help.html"%(direman)
	help = hellp

	def fileselector(self):
		##generate list of open files
		self.files=[]
		self.index=0
		self.files=map(lambda x:x.name,chimera.openModels.list())
		self.fileButton.setitems(self.files)
		
	def addtoatomlist(self):
		i=0
		self.selectedAtoms=[]
		while i < self.lenselected:
			self.selectedAtoms.append(chimera.selection.currentAtoms()[i].serialNumber)
			i=i+1
		self.selectedAtoms.sort()
	
		chain=self.chainid.get()
		sse=self.var.get()
		atoms=self.selectedAtoms

		self.chainlist.append(chain)
		self.sselist.append(sse)
		self.atomlist.append(atoms)
		
		text=[sse, chain, atoms]
		self.displayinfo.append(text)
		self.combobox.component("scrolledlist").setlist(self.displayinfo)
		
	def removefromatomlist(self):
		currentitem=self.combobox.get()
		j=0
		while j< len(self.displayinfo):
			print self.displayinfo[j]
			if self.displayinfo[j]==eval(currentitem):
				removeindex=j
			j=j+1
		del self.displayinfo[removeindex]
		self.combobox.component("scrolledlist").setlist(self.displayinfo)
		
	def displayselected(self):
		showitem=eval(self.combobox.get())
		h=0
		while h < len(self.selectionlist):
			i=0
			selection=self.selectionlist[h]
			compareselection=[]
			while i < len(selection):
				compareselection.append(selection[i].serialNumber)
				i=i+1
			compareselection.sort()
			if compareselection==showitem[2]:
				chimera.selection.setCurrent(selection)
			h=h+1
			
	def fillInUI(self, parent):
		self.chainlist=[]
		self.atomlist=[]
		self.sselist=[]
		self.displayinfo=[]
		self.selectionlist=[]
				
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, columnspan=2, sticky=EW)				
		self.frame1=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame1.grid(column=0,row=1, sticky=EW)
		self.frame2=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame2.grid(column=1,row=2, sticky=EW)
		self.frame3=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame3.grid(column=0,row=3, columnspan=2, sticky=EW)
		self.frame4=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame4.grid(column=1,row=1, sticky=EW)
		
		Label(self.frame0, text='input file:').grid(row=0, column=0, sticky=W)
		self.infile=StringVar()
		self.fileButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.infile)
		self.fileButton.grid(row=0, column=1, sticky=E)
		self.fileselector()
		
		self.combobox=Pmw.ComboBox(self.frame1, label_text='SSE', labelpos='wn', dropdown=0, scrolledlist_items=self.displayinfo)
		self.combobox.grid(row=0, column=0, sticky=W)
		Button(self.frame4,text='Show', command=self.displayselected).grid(row=3, column=0, sticky=W)
		Button(self.frame4,text='Add', command=self.Add).grid(row=1, column=0, sticky=W)
		Button(self.frame4,text='Delete', command=self.Delete).grid(row=2, column=0, sticky=W)
		
		self.var= StringVar()
		for text in [('Helix'), ('Sheet'), ('Coil')]:
			Radiobutton(self.frame4, text=text, value=text, variable=self.var).grid(sticky=W)
		self.var.set('Coil')
		
		Label(self.frame4, text='ID').grid(row=0, column=0, sticky=W)
		self.chainid = Entry(self.frame4, width = 5)
		self.chainid.grid(row=0, column=1, sticky=W)

	def Add(self):
		selected=chimera.selection.currentAtoms()
		self.selectionlist.append(selected)
		print selected
		self.lenselected=len(selected)
		self.addtoatomlist()

	def Delete(self):
		self.removefromatomlist()
	
	def Build(self):
		outDejavu=open("helix.sse","w")
		outDejavu.write("!\n")
		outDejavu.write("!  ===  0dum\n")
		outDejavu.write("!\n")
		outDejavu.write("MOL   0dum\n")
		outDejavu.write("NOTE  from helixhunter3.py\n")
		outDejavu.write("PDB   1SSE\n")
		outDejavu.write("!\n")
		
		filename = str(self.infile.get())
		file=open(filename, "r")
		lines=file.readlines()
		file.close
		x=[]
		y=[]
		z=[]
		atomNumber=[]
		counter=0

		for line in lines:
			isatom=str(line[0:6].strip())
			if (isatom=="ATOM"):
				x.append(float(line[30:38].strip()))
				y.append(float(line[38:46].strip()))
				z.append(float(line[46:54].strip()))
				atomNumber.append(int(line[6:11].strip()))
				counter=counter+1
		
		k=0
		while k < len(self.displayinfo):
			buildlist=self.displayinfo[k]
			print buildlist
			if buildlist[0] == 'Helix':
				helixpoints=[]
				helixlength=0.0
				q=0
				while q < len(atomNumber):
					if atomNumber[q] in buildlist[2]:
						helixpoints.append(q)
					q=q+1
				for point1 in helixpoints:
					for point2 in helixpoints:
						distance=math.sqrt((x[point1]-x[point2])**2+(y[point1]-y[point2])**2+(z[point1]-z[point2])**2)
						if distance >= helixlength:
							helixlength=distance
							hpoint1=[x[point1], y[point1], z[point1]]
							hpoint2=[x[point2], y[point2], z[point2]]
				intlength=int(math.ceil(helixlength/1.54))
				dejavuline="ALPHA 'A%d' '%d' '%d' %d %f %f %f %f %f %f\n"%(k,k*100,k*100+(intlength-1),intlength,hpoint1[0],hpoint1[1],hpoint1[2],hpoint2[0],hpoint2[1],hpoint2[2])
				outDejavu.write(dejavuline)			
			k=k+1
		outDejavu.close()
		outfile="hh-%s"%(filename)
		cmdHH="dejavu2pdb.py helix.sse %s"%(outfile)
		os.system(cmdHH)
		chimera.openModels.open(outfile)

try:
	chimera.dialogs.register(ssebuilder.name, ssebuilder)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = ssebuilder()
	dialog.enter()
def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) : dialog.fileselector()

triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)
